//////////////////////////////////////////////////////////////////////////
// Copyright 2005-2008 Aspose Pty Ltd. All Rights Reserved.
//
// This file is part of Aspose.Editor. The source code in this file
// is only intended as a supplement to the documentation, and is provided
// "as is", without warranty of any kind, either expressed or implied.
//////////////////////////////////////////////////////////////////////////

using System;
using System.Drawing;
using System.Windows.Forms;

namespace Aspose.Editor.Demo
{
    /// <summary>
    /// Summary description for DropDownButton.
    /// </summary>
    public class DropDownButton : UserControl
    {
        #region Component Designer generated code
        private System.Windows.Forms.Button mButton;
        private System.Windows.Forms.CheckBox mDrop;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if(components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }


        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.mButton = new System.Windows.Forms.Button();
            this.mDrop = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            //
            // mButton
            //
            this.mButton.Dock = System.Windows.Forms.DockStyle.Fill;
            this.mButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.mButton.Location = new System.Drawing.Point(0, 0);
            this.mButton.Name = "mButton";
            this.mButton.Size = new System.Drawing.Size(148, 24);
            this.mButton.TabIndex = 0;
            //
            // mDrop
            //
            this.mDrop.Appearance = System.Windows.Forms.Appearance.Button;
            this.mDrop.Dock = System.Windows.Forms.DockStyle.Right;
            this.mDrop.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.mDrop.Location = new System.Drawing.Point(148, 0);
            this.mDrop.Name = "mDrop";
            this.mDrop.Size = new System.Drawing.Size(12, 24);
            this.mDrop.TabIndex = 1;
            this.mDrop.Text = ">";
            this.mDrop.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            //
            // DropDownButton
            //
            this.Controls.Add(this.mButton);
            this.Controls.Add(this.mDrop);
            this.Name = "DropDownButton";
            this.Size = new System.Drawing.Size(160, 24);
            this.ResumeLayout(false);

        }
        #endregion

        public DropDownButton()
        {
            // This call is required by the Windows.Forms Form Designer.
            InitializeComponent();

            // TODO: Add any initialization after the InitializeComponent call
            mDrop.CheckedChanged += new System.EventHandler(mDrop_CheckedChanged);
        }


        /// <summary>
        /// Gets main button control.
        /// </summary>
        public Button Button
        {
            get { return mButton; }
        }


        /// <summary>
        /// Gets drop down control.
        /// </summary>
        public CheckBox DropDown
        {
            get { return mDrop; }
        }


        /// <summary>
        /// Gets or sets context menu which appears when drop button is depressed.
        /// </summary>
        public ContextMenu Menu
        {
            get { return mMenu; }
            set { mMenu = value; }
        }


        private ContextMenu mMenu;

        private void mDrop_CheckedChanged(object sender, EventArgs e)
        {
            if ( null == mMenu )
            {
                mDrop.CheckState = CheckState.Unchecked;
            }

            else
            if ( mDrop.CheckState == CheckState.Checked )
            {
                mMenu.Show(this, new Point(0, Height));
                mDrop.CheckState = CheckState.Unchecked;
            }
        }
    }
}
