//////////////////////////////////////////////////////////////////////////
// Copyright 2005-2008 Aspose Pty Ltd. All Rights Reserved.
//
// This file is part of Aspose.Editor. The source code in this file
// is only intended as a supplement to the documentation, and is provided
// "as is", without warranty of any kind, either expressed or implied.
//////////////////////////////////////////////////////////////////////////

using System;
using System.IO;
using System.Windows.Forms;

namespace Aspose.Editor.Demo
{
    /// <summary>
    /// Summary description for OpenDocumentDialog.
    /// </summary>
    public class OpenDocumentDialog : Form
    {
        #region Windows Form Designer generated code

        private System.ComponentModel.Container components = null;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.ListView mListDocuments;
        private System.Windows.Forms.Button mButtonCancel;
        private System.Windows.Forms.Button mButtonOpen;
        private System.Windows.Forms.TextBox mTextUpload;
        private System.Windows.Forms.Button mButtonUpload;
        private System.Windows.Forms.Button mButtonBrowse;
        private DropDownButton mButtonDownload;
        private System.Windows.Forms.Button mButtonDelete;
        private readonly AppPlugin mApp;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }


        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.mListDocuments = new System.Windows.Forms.ListView();
            this.mButtonCancel = new System.Windows.Forms.Button();
            this.mButtonOpen = new System.Windows.Forms.Button();
            this.mTextUpload = new System.Windows.Forms.TextBox();
            this.mButtonUpload = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.mButtonBrowse = new System.Windows.Forms.Button();
            this.mButtonDownload = new DropDownButton();
            this.mButtonDelete = new System.Windows.Forms.Button();
            this.SuspendLayout();
            //
            // mListDocuments
            //
            this.mListDocuments.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    ((((System.Windows.Forms.AnchorStyles.Top
                        | System.Windows.Forms.AnchorStyles.Bottom)
                | System.Windows.Forms.AnchorStyles.Left)
                | System.Windows.Forms.AnchorStyles.Right)));
            this.mListDocuments.Font =
                new System.Drawing.Font("Microsoft Sans Serif", 12F,
                    System.Drawing.FontStyle.Regular,
                    System.Drawing.GraphicsUnit.Point, ((System.Byte) (204)));
            this.mListDocuments.Location = new System.Drawing.Point(8, 32);
            this.mListDocuments.MultiSelect = false;
            this.mListDocuments.Name = "mListDocuments";
            this.mListDocuments.Size = new System.Drawing.Size(510, 208);
            this.mListDocuments.TabIndex = 10;
            this.mListDocuments.View = System.Windows.Forms.View.List;
            this.mListDocuments.KeyDown +=
                new System.Windows.Forms.KeyEventHandler(
                    this.mListDocuments_KeyDown);
            this.mListDocuments.DoubleClick +=
                new System.EventHandler(this.mListDocuments_DoubleClick);
            this.mListDocuments.SelectedIndexChanged +=
                new System.EventHandler(this.mListDocuments_SelectedIndexChanged);
            //
            // mButtonCancel
            //
            this.mButtonCancel.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    ((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.mButtonCancel.DialogResult =
                System.Windows.Forms.DialogResult.Cancel;
            this.mButtonCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.mButtonCancel.Location = new System.Drawing.Point(408, 344);
            this.mButtonCancel.Name = "mButtonCancel";
            this.mButtonCancel.Size = new System.Drawing.Size(112, 23);
            this.mButtonCancel.TabIndex = 80;
            this.mButtonCancel.Text = "&Cancel";
            //
            // mButtonOpen
            //
            this.mButtonOpen.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    ((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Left)));
            this.mButtonOpen.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.mButtonOpen.Enabled = false;
            this.mButtonOpen.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.mButtonOpen.Location = new System.Drawing.Point(8, 248);
            this.mButtonOpen.Name = "mButtonOpen";
            this.mButtonOpen.Size = new System.Drawing.Size(72, 24);
            this.mButtonOpen.TabIndex = 20;
            this.mButtonOpen.Text = "&Open";
            this.mButtonOpen.Click +=
                new System.EventHandler(this.mButtonOpen_Click);
            //
            // mTextUpload
            //
            this.mTextUpload.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    (((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Left)
                | System.Windows.Forms.AnchorStyles.Right)));
            this.mTextUpload.Location = new System.Drawing.Point(8, 304);
            this.mTextUpload.Name = "mTextUpload";
            this.mTextUpload.Size = new System.Drawing.Size(512, 22);
            this.mTextUpload.TabIndex = 50;
            this.mTextUpload.Text = "";
            this.mTextUpload.KeyPress +=
                new System.Windows.Forms.KeyPressEventHandler(
                    this.mTextUpload_KeyPress);
            this.mTextUpload.TextChanged +=
                new System.EventHandler(this.mTextUpload_TextChanged);
            //
            // mButtonUpload
            //
            this.mButtonUpload.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    ((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Left)));
            this.mButtonUpload.Enabled = false;
            this.mButtonUpload.Location = new System.Drawing.Point(96, 344);
            this.mButtonUpload.Name = "mButtonUpload";
            this.mButtonUpload.Size = new System.Drawing.Size(80, 24);
            this.mButtonUpload.TabIndex = 70;
            this.mButtonUpload.Text = "&Upload";
            this.mButtonUpload.Click +=
                new System.EventHandler(this.mButtonUpload_Click);
            //
            // label1
            //
            this.label1.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    (((System.Windows.Forms.AnchorStyles.Top
                        | System.Windows.Forms.AnchorStyles.Left)
                | System.Windows.Forms.AnchorStyles.Right)));
            this.label1.Location = new System.Drawing.Point(16, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(496, 16);
            this.label1.TabIndex = 6;
            this.label1.Text = "Choose a document from the server:";
            //
            // label2
            //
            this.label2.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    (((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Left)
                | System.Windows.Forms.AnchorStyles.Right)));
            this.label2.Location = new System.Drawing.Point(8, 280);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(312, 16);
            this.label2.TabIndex = 6;
            this.label2.Text = "Or upload a file from your computer:";
            //
            // mButtonBrowse
            //
            this.mButtonBrowse.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    ((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Left)));
            this.mButtonBrowse.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.mButtonBrowse.Location = new System.Drawing.Point(8, 344);
            this.mButtonBrowse.Name = "mButtonBrowse";
            this.mButtonBrowse.Size = new System.Drawing.Size(72, 24);
            this.mButtonBrowse.TabIndex = 60;
            this.mButtonBrowse.Text = "&Browse...";
            this.mButtonBrowse.Click +=
                new System.EventHandler(this.mButtonBrowse_Click);
            //
            // mButtonDownload
            //
            this.mButtonDownload.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    ((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Left)));
            this.mButtonDownload.Enabled = false;
            this.mButtonDownload.Location = new System.Drawing.Point(96, 248);
            this.mButtonDownload.Name = "mButtonDownload";
            this.mButtonDownload.Size = new System.Drawing.Size(80, 24);
            this.mButtonDownload.TabIndex = 30;
            this.mButtonDownload.Text = "&Download";
            //
            // mButtonDelete
            //
            this.mButtonDelete.Anchor =
                ((System.Windows.Forms.AnchorStyles)
                    ((System.Windows.Forms.AnchorStyles.Bottom
                        | System.Windows.Forms.AnchorStyles.Left)));
            this.mButtonDelete.Enabled = false;
            this.mButtonDelete.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.mButtonDelete.Location = new System.Drawing.Point(448, 248);
            this.mButtonDelete.Name = "mButtonDelete";
            this.mButtonDelete.Size = new System.Drawing.Size(72, 24);
            this.mButtonDelete.TabIndex = 40;
            this.mButtonDelete.Text = "Dele&te";
            this.mButtonDelete.Click +=
                new System.EventHandler(this.mButtonDelete_Click);
            //
            // OpenDocumentDialog
            //
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.CancelButton = this.mButtonCancel;
            this.ClientSize = new System.Drawing.Size(528, 381);
            this.ControlBox = false;
            this.Controls.Add(this.mButtonDownload);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.mButtonCancel);
            this.Controls.Add(this.mTextUpload);
            this.Controls.Add(this.mButtonUpload);
            this.Controls.Add(this.mListDocuments);
            this.Controls.Add(this.mButtonOpen);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.mButtonBrowse);
            this.Controls.Add(this.mButtonDelete);
            this.Font = new System.Drawing.Font("Tahoma", 9F);
            this.MinimumSize = new System.Drawing.Size(536, 304);
            this.Name = "OpenDocumentDialog";
            this.StartPosition =
                System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Browse Documents";
            this.ResumeLayout(false);
        }

        #endregion

        public OpenDocumentDialog(AppPlugin app)
        {
            mApp = app;

            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            mButtonDownload.Button.Click +=
                new EventHandler(mButtonDownload_Click);
            mButtonDownload.Button.Text = mButtonDownload.Text;

            mButtonDownload.Menu = new ContextMenu(
                new MenuItem[]
                    {
                        new MenuItem("As &Doc", new EventHandler(AsHandler)),
                        new MenuItem("As D&ocx", new EventHandler(AsHandler)),
                        new MenuItem("As &Html", new EventHandler(AsHandler)),
                        new MenuItem("As &Rtf", new EventHandler(AsHandler)),
                        new MenuItem("As &Xml", new EventHandler(AsHandler)),
                    }
                );

            // Not available yet.
            mButtonDownload.DropDown.Enabled = false;
            mButtonDownload.DropDown.Visible = false;

            BuildDocumentList();
        }


        /// <summary>
        /// Invoked by the context menu items for the "Download As" button.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void AsHandler(object sender, EventArgs e)
        {
            mButtonDownload_Click(sender, e);
        }


        /// <summary>
        /// Builds list of documents on the server.
        /// </summary>
        private void BuildDocumentList()
        {
            mListDocuments.Clear();
            string[] list = mApp.Browse();
            if (list != null)
                for (int i = 0; i < list.Length; i++)
                    mListDocuments.Items.Add(list[i]);

            UpdateOpenDownloadDeleteButtons();
        }


        private void BrowseDocument(bool isAutoUpload)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = mDialogFilter;
            openFileDialog.FileName = string.Empty;

            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                mTextUpload.Text = openFileDialog.FileName;

                if (isAutoUpload)
                    UploadDocument();
            }
        }


        private void UploadDocument()
        {
            string fileName = mTextUpload.Text;
            if (fileName.Length == 0)
                return;

            FileStream stream = new FileStream(fileName, FileMode.Open);
            long fileSize = stream.Length;
            stream.Close();

            if (!mApp.CheckUpload(Path.GetFileName(fileName), fileSize))
                return;

            mApp.UploadDocumentImpl(fileName);
            BuildDocumentList();
        }


        private void LoadDocument()
        {
            if (mListDocuments.SelectedItems.Count > 0)
            {
                
                mApp.LoadDocumentImpl(mListDocuments.SelectedItems[0].Text);
                Close();
            }
        }


        private void DeleteDocument()
        {
            ListView.SelectedListViewItemCollection items =
                mListDocuments.SelectedItems;
            foreach (ListViewItem item in items)
                if ((item.Text != null) && (item.Text.Length > 0))
                    mApp.ExecServerCommand(
                        string.Format("cmd=delete&file={0}", item.Text));
            BuildDocumentList();
        }


        /// <summary>
        /// Browses for a document on local computer and returns selected name, or Null if nothing was selected.
        /// </summary>
        /// <returns></returns>
        internal static string BrowseOpenFile()
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = mDialogFilter;
            dialog.FileName = string.Empty;

            if (DialogResult.OK != dialog.ShowDialog())
                return null;

            return dialog.FileName;
        }

        private const string mDialogFilter =
            "All Documents (*.docx;*.dotx;*.doc;*.dot;*.docm;*.dotm;*.htm;*.html;*.xhtml;*.rtf;*.xml;*.wml)|" +
            "*.docx;*.dotx;*.doc;*.dot;*.docm;*.dotm;*.htm;*.html;*.xhtml;*.rtf;*.xml;*.wml|" +
            "Word Documents (*.docx;*.dotx;*.doc;*.dot;*.docm;*.dotm)|*.docx;*.dotx;*.doc;*.dot;*.docm;*.dotm|" +
            "Web Pages (*.htm;*.html;*.xhtml)|*.htm;*.html;*.xhtml|" +
            "Rich Text Format (*.rtf)|*.rtf|" +
            "XML Files (*.xml;*.wml)|*.xml;*.wml|" +
            "All Files (*.*)|*.*";


        /// <summary>
        /// Browses for a document on local computer and returns selected name, or Null if nothing was selected.
        /// </summary>
        internal static void BrowseSaveFile(string fileName, Stream fileStream)
        {
            mSaveFileDialog.CheckPathExists = true;
            mSaveFileDialog.FileName = fileName;
            mSaveFileDialog.Title = "Save File As";
            mSaveFileDialog.OverwritePrompt = true;
            mSaveFileDialog.ValidateNames = true;
            mSaveFileDialog.Filter = "All files (*.*)|*.*";

            while (true)
            {
                if (DialogResult.OK != mSaveFileDialog.ShowDialog())
                    break;

                string filePath = mSaveFileDialog.FileName;
                if (0 >= filePath.Length)
                    continue;

                using ( FileStream dstStream = new FileStream(filePath, FileMode.Create) )
                    AppPlugin.CopyStream(fileStream, dstStream);

                break;
            }
        }


        private static SaveFileDialog mSaveFileDialog = new SaveFileDialog();

        private void mButtonOpen_Click(object sender, EventArgs e)
        {
            LoadDocument();
        }


        private void mListDocuments_SelectedIndexChanged(object sender, EventArgs e)
        {
            UpdateOpenDownloadDeleteButtons();
        }


        private void UpdateOpenDownloadDeleteButtons()
        {
            mButtonDownload.Enabled =
            mButtonDelete.Enabled =
            mButtonOpen.Enabled =
                (mListDocuments.SelectedIndices.Count > 0);
        }


        private void mButtonBrowse_Click(object sender, EventArgs e)
        {
            BrowseDocument(false);
        }


        private void mButtonUpload_Click(object sender, EventArgs e)
        {
            UploadDocument();
        }


        private void mButtonDownload_Click(object sender, EventArgs e)
        {
            string format = "";
            MenuItem menuItem = sender as MenuItem;
            if (null != menuItem)
                format = menuItem.Text.Substring(3).Replace("&", "").ToLower();
            String fileName = mListDocuments.SelectedItems[0].Text;
            Stream stream = mApp.DownloadDocumentImpl(fileName, format);
            BrowseSaveFile(fileName, stream);
        }


        private void mButtonDelete_Click(object sender, EventArgs e)
        {
            DeleteDocument();
        }


        private void mListDocuments_DoubleClick(object sender, EventArgs e)
        {
            LoadDocument();
        }


        private void mListDocuments_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
                DeleteDocument();

            else
                if (e.KeyCode == Keys.Insert)
                BrowseDocument(true);
        }


        protected override void OnCreateControl()
        {
            base.OnCreateControl();

            mToolTip = new ToolTip();
            mToolTip.SetToolTip(mTextUpload,
                "Specifies the document on this computer. Click Upload button to upload the document to the server.");
            mToolTip.SetToolTip(mListDocuments,
                "Shows all documents available on the server.\r\n" +
                "Double click the document to open it, press Delete key to remove it, press Insert key to browse for a local document and upload it to the server.");
            mToolTip.SetToolTip(mButtonBrowse,
                "Opens standard file open dialog where you can select a document to upload to the server.");
            mToolTip.SetToolTip(mButtonUpload,
                "Uploads selected document to the server. If no document is selected this button is disabled.");
        }


        private ToolTip mToolTip;

        private void mTextUpload_KeyPress(object sender, KeyPressEventArgs e)
        {
            UpdateUploadButton();
        }


        private void mTextUpload_TextChanged(object sender, EventArgs e)
        {
            UpdateUploadButton();
        }


        private void UpdateUploadButton()
        {
            mButtonUpload.Enabled = (mTextUpload.Text.Length > 0);
        }
    }
}
