//////////////////////////////////////////////////////////////////////////
// Copyright 2005-2008 Aspose Pty Ltd. All Rights Reserved.
//
// This file is part of Aspose.Editor. The source code in this file
// is only intended as a supplement to the documentation, and is provided
// "as is", without warranty of any kind, either expressed or implied.
//////////////////////////////////////////////////////////////////////////

namespace Aspose.Editor.Demo
{
    /// <summary>
    /// Contains values shared by server and client code.
    /// </summary>
    internal class Shared
    {
        /// <summary>
        /// Maximum number of files allowed for single sessison in this demo.
        /// </summary>
        internal const int MaxDocumentsPerSession = 10;

        /// <summary>
        /// Maximum size of a single document in this demo.
        /// </summary>
        internal const int MaxDocumentSize = 250 * 1024;

        /// <summary>
        /// Stream content type for client-server communications.
        /// </summary>
        internal const string ContentType = "Application/X-App-Plugin";

        /// <summary>
        /// Header name associated with custom parameter stored in HTTP request.
        /// </summary>
        internal const string ParamHeader = "X-App-Plugin-Param";
    }
}